#ifndef LINKOBJ_H
#define LINKOBJ_H

#include "linkablemapobj.h"

enum LinkState {undefinedLink,initLink,activeLink,deleteLink};

/////////////////////////////////////////////////////////////////////////////
class LinkObj:public MapObj {
public:
    LinkObj ();
    LinkObj (QCanvas*);
    ~LinkObj ();
    virtual void init ();
    virtual void copy (LinkObj*);
	void setBegin (BranchObj*);
	void setEnd   (BranchObj*);
	void setEnd   (QPoint);
	bool activate ();			// Sets pointers in branchObjects
	void deactivate();			// removes those pointers
	bool isUsed();				// true, if at least on branch uses it
	void updateLink();
	void positionBBox();
	void calcBBoxSize();
	void setVisibility (bool);

private:
	QCanvasLine *line;
	BranchObj *beginBranch;
	BranchObj *endBranch;
	LinkState linkState;	// init during drawing or active
	QPoint beginPos;
	QPoint   endPos;
};

#endif
